--- /dev/null	2012-08-31 05:08:52.000000000 +0400
+++ new/grub/grub-core/commands/solarislegacy.c	2012-08-31 05:08:52.513929459 +0400
@@ -0,0 +1,213 @@
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2012 Daniil Lunev
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <grub/types.h>
+#include <grub/misc.h>
+#include <grub/command.h>
+#include <grub/mm.h>
+#include <grub/err.h>
+#include <grub/dl.h>
+#include <grub/file.h>
+#include <grub/normal.h>
+#include <grub/script_sh.h>
+#include <grub/i18n.h>
+#include <grub/term.h>
+#include <grub/legacy_parse.h>
+#include <grub/crypto.h>
+#include <grub/auth.h>
+#include <grub/disk.h>
+#include <grub/partition.h>
+
+#include "menu_managing.c"
+
+GRUB_MOD_LICENSE ("GPLv3+");
+
+static entries *
+parse_entries(grub_file_t file)
+{
+  entries * list = NULL;
+  entries * current = NULL;
+  init_entries(&list);
+  for(;;) {
+    char * buf = grub_file_getline(file);
+    char * param = buf;
+    char * value;
+    
+    if (! buf) 
+      break;
+  
+    if ((buf[0] == '#') || (buf[0] == ' ') ||
+      (buf[0] == '\t') || (buf[0] == '\n')) {
+      grub_free(buf);
+      continue;
+    }
+
+    while ((*param == ' ') || (*param == '\t'))
+      ++param;
+
+    value = grub_strchr(param, ' ');
+    if (! value)
+      value = grub_strchr(param, '\t');
+
+    if (! value) {
+      grub_free(buf);
+      continue;
+    }
+
+    *value++ = 0;
+    while ((*value == ' ') || (*value == '\t'))
+      ++value;
+
+    if ((*value == '\0') || (*value == '\n')) {
+      grub_free(buf);
+      continue;
+    }
+    
+    if (! grub_strcmp(param, "default")) {
+    } else if (! grub_strcmp(param, "timeout")) {
+    } else if (! grub_strcmp(param, "serial")) {
+    } else if (! grub_strcmp(param, "terminal")) {
+    } else if (! grub_strcmp(param, "title")) {
+      current = new_entry(value, list);
+    } else if (! grub_strcmp(param, "bootfs")) {
+      char * lpath;
+      if (! current) {
+        grub_free(buf);
+        grub_error (GRUB_ERR_INVALID_COMMAND, N_("illumos syntax error"));
+        return NULL;
+      }
+      lpath = grub_strchr(value, '/');
+      *lpath = 0;
+      grub_strcpy(current->entry_info[POOL_LABEL], value);
+      *lpath = '/';
+      grub_strcpy(current->entry_info[DATA_SET], lpath);
+    } else if (! grub_strcmp(param, "kernel$")) {
+      char * ender;
+      ender = grub_strchr(value, ' ');
+      if (! ender)  
+        ender = grub_strchr(value, '\t');
+      if (ender)
+        *ender = 0;
+      grub_strcpy(current->entry_info[KERNEL_PATH], value);
+      if (ender) {
+        ++ender;
+        while ((*ender == ' ') || (*ender == '\t'))
+          ++ender;
+        grub_strcpy(current->entry_info[KERNEL_OPTIONS], ender);
+      }
+    } else if (! grub_strcmp(param, "module$")) {
+      grub_strcpy(current->entry_info[BA_PATH], value);
+    } else {
+      grub_free(buf);
+      continue;
+    }
+    grub_free(buf);
+  }
+  return list;
+}
+
+static grub_err_t
+grub_solaris_legacy_cmd(struct grub_command *cmd,
+      int argc, char **args)
+{
+  int new_env, extractor;
+  extractor = (cmd->name[0] == 'e');
+  new_env = (cmd->name[extractor ? (sizeof ("extract_slegacy_entries_") - 1)
+           : (sizeof ("slegacy_") - 1)] == 'c');
+
+
+  if (argc != 1)
+    return grub_error (GRUB_ERR_BAD_ARGUMENT, N_("filename expected"));
+
+  grub_file_t file = grub_file_open(args[0]);
+
+  if (new_env)
+    grub_cls ();
+
+  if (new_env && !extractor)
+    grub_env_context_open ();
+  if (extractor)
+    grub_env_extractor_open (!new_env);
+
+  if (! file)
+    return grub_errno;
+
+  entries * list = parse_entries(file);
+
+  if (! list) {
+    return grub_error (GRUB_ERR_INVALID_COMMAND, N_("illumos syntax error"));
+  }
+  
+  add_entries(list);
+
+  if (new_env)
+  {
+    grub_menu_t menu;
+    menu = grub_env_get_menu ();
+    if (menu && menu->size)
+    grub_show_menu (menu, 1, 0);
+    if (!extractor)
+      grub_env_context_close ();
+  }
+  if (extractor)
+    grub_env_extractor_close (!new_env);
+
+  clear_entries(list);
+
+  grub_file_close(file);
+  return 0;
+}
+
+static grub_command_t cmd_source, cmd_configfile;
+static grub_command_t cmd_source_extract, cmd_configfile_extract;
+
+GRUB_MOD_INIT(solaris_legacy)
+{  
+  cmd_source
+    = grub_register_command ("slegacy_source",
+           grub_solaris_legacy_cmd,
+           N_("FILE"),
+           /* TRANSLATORS: "legacy config" means
+        "config as used by grub-legacy".  */
+           N_("Parse legacy config in same context"));
+  cmd_configfile
+    = grub_register_command ("slegacy_configfile",
+           grub_solaris_legacy_cmd,
+           N_("FILE"),
+           N_("Parse legacy config in new context"));
+  cmd_source_extract
+    = grub_register_command ("extract_slegacy_entries_source",
+           grub_solaris_legacy_cmd,
+           N_("FILE"),
+           N_("Parse legacy config in same context taking only menu entries"));
+  cmd_configfile_extract
+    = grub_register_command ("extract_slegacy_entries_configfile",
+           grub_solaris_legacy_cmd,
+           N_("FILE"),
+           N_("Parse legacy config in new context taking only menu entries"));
+
+
+}
+
+GRUB_MOD_FINI(solaris_legacy) 
+{
+  grub_unregister_command (cmd_source);
+  grub_unregister_command (cmd_configfile);
+  grub_unregister_command (cmd_source_extract);
+  grub_unregister_command (cmd_configfile_extract);
+}
--- old/grub/grub-core/fs/zfs/zfs.c	2012-08-31 05:08:52.910868093 +0400
+++ new/grub/grub-core/fs/zfs/zfs.c	2012-08-31 05:08:52.975514462 +0400
@@ -2,6 +2,7 @@
  *  GRUB  --  GRand Unified Bootloader
  *  Copyright (C) 1999,2000,2001,2002,2003,2004,2009,2010,2011  Free Software Foundation, Inc.
  *  Copyright 2010  Sun Microsystems, Inc.
+ *  Copyright 2012  Daniil Lunev
  *
  *  GRUB is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -224,6 +225,20 @@
   } *keyring;
 };
 
+static const char * feature_list[] = {
+  "localhost:unknown_feature",
+  NULL,
+};
+
+typedef enum zfs_feature_id {
+  ZFS_FEATURE_UNKNOWN,
+} zfs_feature_id_t;
+
+struct enabled_feature_list {
+  struct enabled_feature_list * next;
+  zfs_feature_id_t id;
+};
+
 struct grub_zfs_data
 {
   /* cache for a file block of the currently zfs_open()-ed file */
@@ -249,6 +264,8 @@
 
   uberblock_t current_uberblock;
 
+  struct enabled_feature_list * feature_list;
+  
   int mounted;
   grub_uint64_t guid;
 };
@@ -482,15 +499,11 @@
 
   if (grub_zfs_to_cpu64 (uber->ub_magic, GRUB_ZFS_LITTLE_ENDIAN)
       == UBERBLOCK_MAGIC
-      && grub_zfs_to_cpu64 (uber->ub_version, GRUB_ZFS_LITTLE_ENDIAN) > 0 
-      && grub_zfs_to_cpu64 (uber->ub_version, GRUB_ZFS_LITTLE_ENDIAN)
-      <= SPA_VERSION)
+      && grub_zfs_to_cpu64 (uber->ub_version, GRUB_ZFS_LITTLE_ENDIAN) > 0)
     endian = GRUB_ZFS_LITTLE_ENDIAN;
 
   if (grub_zfs_to_cpu64 (uber->ub_magic, GRUB_ZFS_BIG_ENDIAN) == UBERBLOCK_MAGIC
-      && grub_zfs_to_cpu64 (uber->ub_version, GRUB_ZFS_BIG_ENDIAN) > 0 
-      && grub_zfs_to_cpu64 (uber->ub_version, GRUB_ZFS_BIG_ENDIAN)
-      <= SPA_VERSION)
+      && grub_zfs_to_cpu64 (uber->ub_version, GRUB_ZFS_BIG_ENDIAN) > 0)
     endian = GRUB_ZFS_BIG_ENDIAN;
 
   if (endian == GRUB_ZFS_UNKNOWN_ENDIAN)
@@ -836,15 +849,6 @@
       return grub_errno;
     }
   grub_dprintf ("zfs", "check 8 passed\n");
-
-  if (version > SPA_VERSION)
-    {
-      grub_free (nvlist);
-      return grub_error (GRUB_ERR_NOT_IMPLEMENTED_YET,
-			 "too new version %llu > %llu",
-			 (unsigned long long) version,
-			 (unsigned long long) SPA_VERSION);
-    }
   grub_dprintf ("zfs", "check 9 passed\n");
 
   found = grub_zfs_nvlist_lookup_uint64 (nvlist, ZPOOL_CONFIG_GUID,
@@ -1774,11 +1778,11 @@
   for (i = 0; i < chunks; i++)
     {
       if (case_insensitive ? (grub_strcasecmp (mzap_ent[i].mze_name, name) == 0)
-	  : (grub_strcmp (mzap_ent[i].mze_name, name) == 0))
-	{
-	  *value = grub_zfs_to_cpu64 (mzap_ent[i].mze_value, endian);
-	  return GRUB_ERR_NONE;
-	}
+    	    : (grub_strcmp (mzap_ent[i].mze_name, name) == 0))
+ 	  {
+	    *value = grub_zfs_to_cpu64 (mzap_ent[i].mze_value, endian);
+	    return GRUB_ERR_NONE;
+	  }
     }
 
   return grub_error (GRUB_ERR_FILE_NOT_FOUND, N_("file `%s' not found"), name);
@@ -2670,56 +2674,49 @@
   return err;
 }
 
-#if 0
+#if 1
 /*
  * Get the default 'bootfs' property value from the rootpool.
  *
  */
 static grub_err_t
-get_default_bootfsobj (dnode_phys_t * mosmdn, grub_uint64_t * obj,
+get_default_bootfsobj (dnode_end_t * mosmdn, grub_uint64_t * obj,
 		       struct grub_zfs_data *data)
 {
   grub_uint64_t objnum = 0;
-  dnode_phys_t *dn;
-  if (!dn)
-    return grub_errno;
+  dnode_end_t dn;
 
   if ((grub_errno = dnode_get (mosmdn, DMU_POOL_DIRECTORY_OBJECT,
-			       DMU_OT_OBJECT_DIRECTORY, dn, data)))
+			       DMU_OT_OBJECT_DIRECTORY, &dn, data)))
     {
-      grub_free (dn);
       return (grub_errno);
     }
-
   /*
    * find the object number for 'pool_props', and get the dnode
    * of the 'pool_props'.
    */
-  if (zap_lookup (dn, DMU_POOL_PROPS, &objnum, data))
+  if (zap_lookup (&dn, DMU_POOL_PROPS, &objnum, data, 0))
     {
-      grub_free (dn);
       return (GRUB_ERR_BAD_FS);
     }
-  if ((grub_errno = dnode_get (mosmdn, objnum, DMU_OT_POOL_PROPS, dn, data)))
+  if ((grub_errno = dnode_get (mosmdn, objnum, DMU_OT_POOL_PROPS, &dn, data)))
     {
-      grub_free (dn);
       return (grub_errno);
     }
-  if (zap_lookup (dn, ZPOOL_PROP_BOOTFS, &objnum, data))
+  if (zap_lookup (&dn, ZPOOL_PROP_BOOTFS, &objnum, data,0))
     {
-      grub_free (dn);
       return (GRUB_ERR_BAD_FS);
     }
 
   if (!objnum)
     {
-      grub_free (dn);
       return (GRUB_ERR_BAD_FS);
     }
 
   *obj = objnum;
   return (0);
 }
+
 #endif
 /*
  * Given a MOS metadnode, get the metadnode of a given filesystem name (fsname),
@@ -3320,9 +3317,117 @@
   for (i = 0; i < data->subvol.nkeys; i++)
     grub_crypto_cipher_close (data->subvol.keyring[i].cipher);
   grub_free (data->subvol.keyring);
+  while (data->feature_list) {
+    struct enabled_feature_list * tmp = data->feature_list;
+    data->feature_list = data->feature_list->next;
+    grub_free(tmp);
+  }
   grub_free (data);
 }
 
+static int 
+add_feature (struct grub_zfs_data * data, zfs_feature_id_t id)
+{
+  struct enabled_feature_list * list = data->feature_list;
+  
+  while (list->next) {
+    if (list->next->id == id)
+      return id;
+    list = list->next;
+  }
+  
+  list->next = (struct enabled_feature_list *) grub_zalloc (sizeof (struct enabled_feature_list)); 
+  
+  if (! list->next)
+    return (-1);
+
+  list->next->id = id;
+  list->next->next = NULL;
+  
+  return 0;
+}
+
+static zfs_feature_id_t
+check_feature (const char * feature)
+{
+  int i = 0;
+  for ( ; i < ZFS_FEATURE_UNKNOWN; ++i)
+    if (! grub_strcmp (feature, feature_list[i]))
+	  return i;
+
+  return ZFS_FEATURE_UNKNOWN;
+}
+
+/*
+ * zfs_get_features_list() get feature list and check compatability
+ */
+static grub_err_t
+zfs_get_features_list (struct grub_zfs_data * data)
+{
+  dnode_end_t dn;
+  dnode_end_t * mos = &(data->mos);
+  grub_err_t err;
+  grub_uint64_t objnum;
+  int ret;
+  
+  int NESTED_FUNC_ATTR feature_hook (const char * cname, grub_uint64_t val)
+  {
+    grub_err_t iret = 0;
+
+    zfs_feature_id_t id;
+
+    if (! (*cname))
+      goto out;
+
+    // retrieve feature number
+    id = check_feature (cname);
+
+    // if grub doesn't support such feature, return error
+    if (id == ZFS_FEATURE_UNKNOWN) {
+      if (val == 0) {
+        grub_error(GRUB_ERR_BAD_FS, 
+              "Unsupported feature %s was enabled,"
+              " but haven't been activated yet. You will not be able to boot"
+              " if this feature are activated.", cname);
+      } else {
+        grub_error(GRUB_ERR_BAD_FS, 
+            "Unsupported feature %s is activated. Booting failed",cname);
+        iret = 1;
+      }
+      goto out;
+    }
+	
+    // add feature to list
+    iret = add_feature(data, id);
+	
+  out:
+    return iret;
+  }
+  
+  // get object directory
+  err = dnode_get (mos, DMU_POOL_DIRECTORY_OBJECT,
+            DMU_OT_OBJECT_DIRECTORY, &dn, data);
+  if (err)
+    return err;
+
+  // retrieve pool properties object numer
+  err = zap_lookup (&dn, DMU_POOL_FEATURES_FOR_READ, &objnum, data, 0);
+  if (err)
+    return err;
+  
+  // get "features for read" zap dnode
+  err = dnode_get (mos, objnum, DMU_OTN_ZAP_METADATA, &dn, data);
+  if (err)
+    return err;
+  
+  // itterate zap to fetch feature list
+  ret = zap_iterate_u64 (&dn, feature_hook, data);
+  if (ret)
+    return grub_error(GRUB_ERR_BAD_FS, "There are enabled unsupported features");
+    	
+  return GRUB_ERR_NONE;
+} 
+
 /*
  * zfs_mount() locates a valid uberblock of the root pool and read in its MOS
  * to the memory address MOS.
@@ -3354,6 +3459,7 @@
     grub_memset (&current_uberblock, 0, sizeof (uberblock_t));
 #endif
 
+  data->feature_list = NULL;
   data->n_devices_allocated = 16;
   data->devices_attached = grub_malloc (sizeof (data->devices_attached[0])
 					* data->n_devices_allocated);
@@ -3392,12 +3498,116 @@
   data->mos.endian = (grub_zfs_to_cpu64 (ub->ub_rootbp.blk_prop,
 					 ub_endian) >> 63) & 1;
   grub_free (osp);
-
+  
   data->mounted = 1;
 
+  if (grub_zfs_to_cpu64(ub->ub_version, ub_endian) == SPA_FEATURE_VERSION) {
+    data->feature_list = (struct enabled_feature_list*) grub_zalloc (
+                                                  sizeof (struct enabled_feature_list));
+    data->feature_list->next = NULL;
+    err = zfs_get_features_list(data);
+  
+    if (err) {
+      data->mounted = 0;
+      zfs_unmount (data);
+      return NULL;
+    }
+  }
+
   return data;
 }
 
+static grub_err_t
+find_default_dataset_path(char * path, grub_uint64_t * mdnobj, struct grub_zfs_data *data)
+{
+  grub_uint64_t obj, pobj, zobj;
+  grub_err_t err;
+  dnode_end_t mdn, *mosmdn;
+  char buf[512];
+
+  int NESTED_FUNC_ATTR hook (const char * name, grub_uint64_t val) {
+    if (val == obj) {
+      grub_strcpy(buf, name);
+      return 1;
+    }
+    return 0;
+  }
+
+  obj = *mdnobj;
+  mosmdn = &(data->mos);
+  buf[0] = '\0';
+  path[0] = '\0';
+
+  // get object's data dir
+  err = dnode_get(mosmdn, obj, DMU_OT_DSL_DATASET, &mdn, data);
+  if (err)
+    return err;
+  obj = grub_zfs_to_cpu64((((dsl_dataset_phys_t*)DN_BONUS (&mdn.dn)))->ds_dir_obj, mdn.endian);
+  
+  for (;;) {
+    // get object dnode
+    err = dnode_get(mosmdn, obj, DMU_OT_DSL_DIR, &mdn, data);
+    if (err)
+      return err;
+
+    // find out its parent's objnum
+    pobj = grub_zfs_to_cpu64((((dsl_dir_phys_t*)DN_BONUS (&mdn.dn)))->dd_parent_obj, mdn.endian);
+    if (obj == pobj)
+      break;
+
+    // if pobj is 0 then we have reached top dataset
+    if (! pobj)
+      break;
+
+    // get object's parent dnode
+    err = dnode_get(mosmdn, pobj, DMU_OT_DSL_DIR, &mdn, data);
+    if (err)
+      return err;
+
+    // find out parent's zap objnum
+    zobj = grub_zfs_to_cpu64((((dsl_dir_phys_t*)DN_BONUS (&mdn.dn)))->dd_child_dir_zapobj, mdn.endian);
+
+    // get zap's dnode
+    err = dnode_get(mosmdn, zobj, DMU_OT_DSL_DIR_CHILD_MAP, &mdn, data);
+    if (err)
+      return err;
+
+    // lookup zap to get name
+    err = zap_iterate_u64(&mdn, hook, data); 
+    if (err == 0)
+      return err;
+
+    // pobj becomes obj now
+    obj = pobj;
+
+    // append new intermediate dnode to path
+    grub_strcat(buf, path);
+    grub_strcpy(path, "/");
+    grub_strcat(path, buf);
+  } 
+	
+  return GRUB_ERR_NONE;
+}
+
+grub_err_t
+get_default_bootfs_obj(grub_device_t dev, char * path, grub_uint64_t * mdnobj)
+{
+  struct grub_zfs_data * data;
+  grub_err_t err = 0;
+  data = zfs_mount(dev);
+  if (data) {
+    err = get_default_bootfsobj(&(data->mos), mdnobj, data);
+    if (err)
+      return err;
+    err = find_default_dataset_path(path, mdnobj, data);
+    zfs_unmount(data);
+    return err;
+  } else {
+    return grub_errno;
+  }
+  return 0;
+}
+
 grub_err_t
 grub_zfs_fetch_nvlist (grub_device_t dev, char **nvlist)
 {
--- old/grub/grub-core/fs/zfs/zfsinfo.c	2012-08-31 05:08:54.303066896 +0400
+++ new/grub/grub-core/fs/zfs/zfsinfo.c	2012-08-31 05:08:54.339887022 +0400
@@ -184,9 +184,10 @@
 }
 
 static grub_err_t
-get_bootpath (char *nvlist, char **bootpath, char **devid)
+get_bootpath (char *nvlist, char **bootpath, char **devid, grub_uint64_t inguid)
 {
   char *type = 0;
+  grub_uint64_t diskguid = 0;
 
   type = grub_zfs_nvlist_lookup_string (nvlist, ZPOOL_CONFIG_TYPE);
 
@@ -195,10 +196,11 @@
 
   if (grub_strcmp (type, VDEV_TYPE_DISK) == 0)
     {
+      grub_zfs_nvlist_lookup_uint64 (nvlist, "guid", &diskguid);
       *bootpath = grub_zfs_nvlist_lookup_string (nvlist,
 						 ZPOOL_CONFIG_PHYS_PATH);
       *devid = grub_zfs_nvlist_lookup_string (nvlist, ZPOOL_CONFIG_DEVID);
-      if (!*bootpath || !*devid)
+      if (!*bootpath || !*devid || (diskguid != inguid))
 	{
 	  grub_free (*bootpath);
 	  grub_free (*devid);
@@ -223,7 +225,7 @@
 						       ZPOOL_CONFIG_CHILDREN,
 						       i);
 
-	  get_bootpath (child, bootpath, devid);
+	  get_bootpath (child, bootpath, devid, inguid);
 
 	  grub_free (child);
 
@@ -340,12 +342,16 @@
   char *fsname;
   char *bootfs;
   char *poolname;
-  grub_uint64_t mdnobj;
+  char def_path[512];
+  struct grub_zfs_data * data;
+  grub_uint64_t mdnobj, guid;
+  int def = 0;
 
-  if (argc < 1)
+  if (argc <  1) 
     return grub_error (GRUB_ERR_BAD_ARGUMENT, N_("one argument expected"));
 
   devname = grub_file_get_device_name (args[0]);
+
   if (grub_errno)
     return grub_errno;
 
@@ -362,8 +368,14 @@
   else
     fsname = args[0];
 
-  if (!err)
+  if (grub_strcmp(fsname, "default") == 0)
+    ++def;
+
+  if (! def) {
     err = grub_zfs_getmdnobj (dev, fsname, &mdnobj);
+  } else {
+    err = get_default_bootfs_obj(dev, def_path, &mdnobj);
+  }
 
   grub_device_close (dev);
 
@@ -379,9 +391,10 @@
     }
 
   nv = grub_zfs_nvlist_lookup_nvlist (nvlist, ZPOOL_CONFIG_VDEV_TREE);
+  grub_zfs_nvlist_lookup_uint64 (nvlist, "guid", &guid);
 
-  if (nv)
-    get_bootpath (nv, &bootpath, &devid);
+  if (nv && guid)
+    get_bootpath (nv, &bootpath, &devid, guid);
 
   grub_free (nv);
   grub_free (nvlist);
@@ -401,6 +414,11 @@
   else
     grub_printf ("%s\n", bootfs);
 
+  if ((def) && (argc >= 3))
+    grub_env_set(args[2], def_path);
+  else if (def)
+    grub_printf("%s\n", def_path);
+
   grub_free (bootfs);
   grub_free (poolname);
   grub_free (bootpath);
--- old/grub/grub-core/partmap/sun.c	2012-08-31 05:08:54.982485828 +0400
+++ new/grub/grub-core/partmap/sun.c	2012-08-31 05:08:55.030532646 +0400
@@ -92,7 +92,7 @@
   struct grub_partition p;
   union
   {
-    struct grub_sun_block sun;
+    struct grub_sun_block sunb;
     grub_uint16_t raw[0];
   } block;
   int partnum;
@@ -104,7 +104,7 @@
   if (err)
     return err;
 
-  if (GRUB_PARTMAP_SUN_MAGIC != grub_be_to_cpu16 (block.sun.magic))
+  if (GRUB_PARTMAP_SUN_MAGIC != grub_be_to_cpu16 (block.sunb.magic))
     return grub_error (GRUB_ERR_BAD_PART_TABLE, "not a sun partition table");
 
   if (! grub_sun_is_valid (block.raw))
@@ -116,14 +116,14 @@
     {
       struct grub_sun_partition_descriptor *desc;
 
-      if (block.sun.infos[partnum].id == 0
-	  || block.sun.infos[partnum].id == GRUB_PARTMAP_SUN_WHOLE_DISK_ID)
+      if (block.sunb.infos[partnum].id == 0
+	  || block.sunb.infos[partnum].id == GRUB_PARTMAP_SUN_WHOLE_DISK_ID)
 	continue;
 
-      desc = &block.sun.partitions[partnum];
+      desc = &block.sunb.partitions[partnum];
       p.start = ((grub_uint64_t) grub_be_to_cpu32 (desc->start_cylinder)
-		  * grub_be_to_cpu16 (block.sun.ntrks)
-		  * grub_be_to_cpu16 (block.sun.nsect));
+		  * grub_be_to_cpu16 (block.sunb.ntrks)
+		  * grub_be_to_cpu16 (block.sunb.nsect));
       p.len = grub_be_to_cpu32 (desc->num_sectors);
       p.number = p.index = partnum;
       if (p.len)
--- old/grub/grub-core/partmap/sunpc.c	2012-08-31 05:08:55.614401454 +0400
+++ new/grub/grub-core/partmap/sunpc.c	2012-08-31 05:08:55.653055529 +0400
@@ -74,7 +74,7 @@
   grub_partition_t p;
   union
   {
-    struct grub_sun_pc_block sun;
+    struct grub_sun_pc_block sunb;
     grub_uint16_t raw[0];
   } block;
   int partnum;
@@ -92,7 +92,7 @@
       return err;
     }
   
-  if (GRUB_PARTMAP_SUN_PC_MAGIC != grub_le_to_cpu16 (block.sun.magic))
+  if (GRUB_PARTMAP_SUN_PC_MAGIC != grub_le_to_cpu16 (block.sunb.magic))
     {
       grub_free (p);
       return grub_error (GRUB_ERR_BAD_PART_TABLE, 
@@ -111,12 +111,12 @@
     {
       struct grub_sun_pc_partition_descriptor *desc;
 
-      if (block.sun.partitions[partnum].id == 0
-	  || block.sun.partitions[partnum].id
+      if (block.sunb.partitions[partnum].id == 0
+	  || block.sunb.partitions[partnum].id
 	  == GRUB_PARTMAP_SUN_PC_WHOLE_DISK_ID)
 	continue;
 
-      desc = &block.sun.partitions[partnum];
+      desc = &block.sunb.partitions[partnum];
       p->start = grub_le_to_cpu32 (desc->start_sector);
       p->len = grub_le_to_cpu32 (desc->num_sectors);
       p->number = partnum;
--- old/grub/include/grub/search.h	2012-08-31 05:08:56.261951310 +0400
+++ new/grub/include/grub/search.h	2012-08-31 05:08:56.292524608 +0400
@@ -20,10 +20,10 @@
 #define GRUB_SEARCH_HEADER 1
 
 void grub_search_fs_file (const char *key, const char *var, int no_floppy,
-			  char **hints, unsigned nhints);
+			  char **hints, unsigned nhints, int mirror);
 void grub_search_fs_uuid (const char *key, const char *var, int no_floppy,
-			  char **hints, unsigned nhints);
+			  char **hints, unsigned nhints, int mirror);
 void grub_search_label (const char *key, const char *var, int no_floppy,
-			char **hints, unsigned nhints);
+			char **hints, unsigned nhints, int mirror);
 
 #endif
--- old/grub/include/grub/zfs/dmu.h	2012-08-31 05:08:56.896674744 +0400
+++ new/grub/include/grub/zfs/dmu.h	2012-08-31 05:08:56.925737526 +0400
@@ -19,6 +19,9 @@
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ *  Copyright 2012, Daniil Lunev
+ */
 
 #ifndef	_SYS_DMU_H
 #define	_SYS_DMU_H
@@ -30,6 +33,41 @@
  * The DMU also interacts with the SPA.  That interface is described in
  * dmu_spa.h.
  */
+
+#define  B_FALSE  0
+#define  B_TRUE  1
+
+#define  DMU_OT_NEWTYPE 0x80
+#define  DMU_OT_METADATA 0x40
+#define  DMU_OT_BYTESWAP_MASK 0x3f
+
+#define  DMU_OT(byteswap, metadata) \
+  (DMU_OT_NEWTYPE | \
+  ((metadata) ? DMU_OT_METADATA : 0) | \
+  ((byteswap) & DMU_OT_BYTESWAP_MASK))
+
+#define  DMU_OT_IS_VALID(ot) (((ot) & DMU_OT_NEWTYPE) ? \
+  ((ot) & DMU_OT_BYTESWAP_MASK) < DMU_BSWAP_NUMFUNCS : \
+  (ot) < DMU_OT_NUMTYPES)
+
+#define  DMU_OT_IS_METADATA(ot) (((ot) & DMU_OT_NEWTYPE) ? \
+  ((ot) & DMU_OT_METADATA) : \
+  dmu_ot[(ot)].ot_metadata)
+
+typedef enum dmu_object_byteswap {
+  DMU_BSWAP_UINT8,
+  DMU_BSWAP_UINT16,
+  DMU_BSWAP_UINT32,
+  DMU_BSWAP_UINT64,
+  DMU_BSWAP_ZAP,
+  DMU_BSWAP_DNODE,
+  DMU_BSWAP_OBJSET,
+  DMU_BSWAP_ZNODE,
+  DMU_BSWAP_OLDACL,
+  DMU_BSWAP_ACL,
+  DMU_BSWAP_NUMFUNCS
+} dmu_object_byteswap_t;
+
 typedef enum dmu_object_type {
 	DMU_OT_NONE,
 	/* general: */
@@ -89,7 +127,9 @@
 	DMU_OT_SA_ATTR_REGISTRATION,	/* ZAP */
 	DMU_OT_SA_ATTR_LAYOUTS,		/* ZAP */
 	DMU_OT_DSL_KEYCHAIN = 54,
-	DMU_OT_NUMTYPES
+	DMU_OT_NUMTYPES,
+	
+	DMU_OTN_ZAP_METADATA = DMU_OT(DMU_BSWAP_ZAP, B_TRUE),
 } dmu_object_type_t;
 
 typedef enum dmu_objset_type {
@@ -116,5 +156,6 @@
 #define	DMU_POOL_HISTORY		"history"
 #define	DMU_POOL_PROPS			"pool_props"
 #define	DMU_POOL_L2CACHE		"l2cache"
+#define DMU_POOL_FEATURES_FOR_READ	"features_for_read"
 
 #endif	/* _SYS_DMU_H */
--- old/grub/include/grub/zfs/zfs.h	2012-08-31 05:08:57.526925138 +0400
+++ new/grub/include/grub/zfs/zfs.h	2012-08-31 05:08:57.561499945 +0400
@@ -18,6 +18,9 @@
  /*
   * Copyright (c) 2007, 2010, Oracle and/or its affiliates. All rights reserved.
   */
+/*
+ *  Copyright 2012, Daniil Lunev
+ */
 
 #ifndef	GRUB_ZFS_HEADER
 #define	GRUB_ZFS_HEADER 1
@@ -37,6 +40,7 @@
  * On-disk version number.
  */
 #define	SPA_VERSION			33ULL
+#define	SPA_FEATURE_VERSION		5000ULL
 
 /*
  * The following are configuration names used in the nvlist describing a pool's
@@ -134,6 +138,8 @@
 		  grub_size_t keylen,
 		  int passphrase);
 
+grub_err_t
+get_default_bootfs_obj(grub_device_t dev, char * path, grub_uint64_t * mdnobj);
 extern grub_err_t (*grub_zfs_decrypt) (grub_crypto_cipher_handle_t cipher,
 				       grub_uint64_t algo,
 				       void *nonce,
--- /dev/null	2012-08-31 05:08:58.000000000 +0400
+++ new/grub/util/grub-solarislst2cfg.c	2012-08-31 05:08:58.176823035 +0400
@@ -0,0 +1,274 @@
+/*
+ *  GRUB  --  GRand Unified Bootloader
+ *  Copyright (C) 2012 Daniil Lunev
+ *
+ *  GRUB is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  GRUB is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <grub/types.h>
+#include <grub/emu/misc.h>
+#include <grub/emu/getroot.h>
+#include <grub/fs.h>
+#include <grub/device.h>
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+#define BUFFER_SIZE 512
+
+struct commands {
+  const char * lst;
+  const char * cfg;
+};
+
+void
+get_uuid_by_path(char * path, char ** uuid)
+{
+  char ** devices = NULL;
+  char * drive = NULL;
+  grub_device_t dev = NULL;
+  grub_fs_t fs = NULL;
+  char * grub_path = NULL;
+
+  grub_path = canonicalize_file_name(path);
+  if (! grub_path)
+    grub_util_error("Can't canonicalize path");
+  
+  devices = grub_guess_root_devices(grub_path);
+  if (! devices) 
+    grub_util_error("Can't find device");
+  
+  drive = grub_util_get_grub_dev(devices[0]);
+  if (! drive)
+    grub_util_error("Can't get drive");
+    
+  dev = grub_device_open(drive);
+  if (! dev) 
+    grub_util_error("Can't open device");
+
+  fs = grub_fs_probe(dev);
+  if (! fs) 
+    grub_util_error("Probing fs error");
+
+  if (! fs->uuid) 
+    grub_util_error("This fs doesn't support uuid");
+
+  if (fs->uuid(dev, uuid) != GRUB_ERR_NONE) 
+    grub_util_error("%s", grub_errmsg);
+
+  free(grub_path);
+  if (dev) 
+    grub_device_close(dev);
+
+  return;
+}
+
+struct commands com[] = {
+  {"title", "entry_name"},
+  {"findroot", "pool"},
+  {"bootfs", "data_set"},
+  {"kernel$", "kernel_path"},
+  {"module$", "module"},
+  {"default", "default_entry"},
+  {"timeout", "timeout"},
+  {"serial", "serial"},
+  {"terminal", "terminal"},
+  {0, 0},
+};
+
+int
+get_command_id(char * command)
+{
+  int i = 0;
+  for (; com[i].lst; ++i)
+    if (!strcmp(com[i].lst, command))
+      return i;
+  return -1;
+}
+
+char *
+retrive_value(char * val)
+{
+  char * str; 
+  int quote_flag = 0;;
+
+  while ((*val == ' ') || (*val == '\t'))
+    ++val;
+
+  if (*val == '"') {
+    ++val;
+    ++quote_flag;  
+  }
+  
+  str = val;
+  
+  for (;;) {
+    if (quote_flag) {
+      if (*val == '"') 
+        break;
+      if (*val == '\0')
+        return NULL;
+    } else {
+      if ((*val == ' ') || (*val == '\t') || (*val == '\0'))
+        break;
+    }
+    ++val;
+  }
+  *val = '\0';
+
+  return str;
+}
+
+int
+parse_menulst(FILE * in_file, FILE * out_file)
+{
+  char line[BUFFER_SIZE];
+  char * command;
+  char * value;
+  char * label = NULL;
+  char bootfs[BUFFER_SIZE];
+  char pool[BUFFER_SIZE];
+  char * uuid;
+  char * c;
+  int com_id;
+
+  for (;;) {
+    command = fgets(line, BUFFER_SIZE, in_file);
+    if (! command)
+      return 0;
+
+    c = command + strlen(command) - 1;
+    if ((*c != '\n') && (fgets(line, BUFFER_SIZE, in_file)))
+      return 1;
+
+    if ((*command == '#') || (*command == ' ') 
+       || (*command == '\t') || (*command == '\n'))
+      continue;
+
+    if (*c == '\n')
+      *c = '\0';
+    value = strchr(line, ' ');
+    if (! value)
+      continue;
+
+    *value++ = '\0';
+    
+    com_id = get_command_id(command);
+    if (com_id < 0)
+      continue;
+
+    switch (com_id) {
+    case 0:
+      fprintf(out_file,"\n%s=%s\n", com[com_id].cfg, value);
+      break;
+    case 1:
+      label = strdup(strchr(value, '_') + 1);
+      c = strchr(label, ',');
+      if (c)
+        *c = 0;
+      continue;
+    case 2:
+      c = strchr(value, '/');
+      if (c != NULL) {
+        strcpy(bootfs, c);
+        *c = '\0';
+        strcpy(pool + 1, value);
+        *pool = '/';
+        uuid = NULL;
+        get_uuid_by_path(pool, &uuid);
+        if (! uuid)
+          return 1;
+      
+        fprintf(out_file,"pool_uuid=%s\n", uuid);
+        
+      } 
+      *c = '/';
+      fprintf(out_file,"data_set=%s\n", value);
+      if (label) {
+        free(label);
+        label = NULL;
+      }
+      break;
+    case 3:
+    case 4:
+      if (label) {
+        fprintf(out_file,"pool_label=%s\n", label);
+        free(label);
+        label = NULL;
+      }
+      if (com_id == 3)
+        c = strchr (value, ' ');
+        if (c)
+          *c = '\0';
+      if (! value)
+        return 1;
+      
+      fprintf(out_file,"%s=%s\n", com[com_id].cfg, value);
+
+      if ((com_id == 3) && (c)) {
+        char * tmp;
+        value = c + 1;
+        tmp = strstr(value, "ZFS-BOOTFS");
+        if (tmp)
+          *(tmp + 3) = '_';
+        fprintf(out_file,"kernel_options=%s\n", value);
+      }
+
+      break;
+    default:
+      fprintf(out_file,"%s=%s\n", com[com_id].cfg, value);
+      break;
+    }
+  }
+  return 0;
+}
+
+int
+main(int argc, char ** argv)
+{
+  FILE * lst_file;
+  FILE * cfg_file;
+  int err = 0;
+
+  if (argc != 3) {
+    printf("grub-solarislst2cfg lst_file cfg_file\n");
+    return 1;
+  }
+
+  lst_file = fopen(argv[1], "r");
+  if (! lst_file)
+    return 1;
+
+  cfg_file = fopen(argv[2], "w");
+  if (! cfg_file) {
+    fclose(lst_file);
+    return 1;
+  }
+
+  grub_util_init_nls();
+  grub_util_biosdisk_init(DEFAULT_DEVICE_MAP);
+  grub_init_all();
+  
+  err = parse_menulst(lst_file, cfg_file);
+
+  grub_fini_all();
+
+  fclose(lst_file);
+  fclose(cfg_file);
+
+  if (err)
+    remove(argv[2]);
+  return err;
+}
--- old/grub/util/grub.d/10_illumos.in	2012-08-31 05:08:58.478939825 +0400
+++ new/grub/util/grub.d/10_illumos.in	2012-08-31 05:08:58.513972802 +0400
@@ -49,4 +49,8 @@
 	multiboot $($grub_mkrelpath /platform/i86pc/kernel)/\$ISADIR/unix /platform/i86pc/kernel/\$ISADIR/unix -B \$ZFS_BOOTFS,console=text
 	module $($grub_mkrelpath /platform/i86pc)/\$ISADIR/boot_archive /platform/i86pc/\$ISADIR/boot_archive
 }
+
+submenu 'Illumos-entries' {
+	illumos_entries /@/boot/illumos.cfg 
+}
 EOF
